# -*- coding: utf-8 -*-
# this file is released under public domain and you can use without limitations

#########################################################################
## This is a samples controller
## - index is the default action of any application
## - user is required for authentication and authorization
## - download is for downloading files uploaded in the db (does streaming)
## - call exposes all registered services (none by default)
#########################################################################

error_page=URL(r=request,f='error')

def error():
    return dict(message=T("something is wrong"))


def disqus():
    return dict()


def rh_bar():
    recommended_lists = db((db.top_list.id > 0) & (db.top_list.is_recommended==True)).select(orderby=~db.top_list.likes,limitby=(0,4))
    return dict(recommended_lists=recommended_lists)


def index2():
    limitby=3
    #flashes just one time
    if not session.flashed:
       response.flash=T("Welcome to topl1st")
       session.flashed=True
    
    latest_lists = db(db.top_list.id > 0).select(orderby=~db.top_list.created_on,limitby=(0,limitby))
    popular_lists = db(db.top_list.id > 0).select(orderby=~db.top_list.likes,limitby=(0,limitby))
    video_lists = db((db.top_list.id > 0) & (db.top_list.category_id == 31)).select(orderby=~db.top_list.likes,limitby=(0,limitby))
    image_lists = db((db.top_list.id > 0) & (db.top_list.category_id == 30)).select(orderby=~db.top_list.likes,limitby=(0,limitby))
    f,v=request.args(0),request.args(1)
    try: query=f and db.category[f]==v or db.category
    except: redirect(URL('error'))
    categories=db(query)(db.category.active==True).select()
    
    return dict(message='Welcome to topl1st', latest_lists=latest_lists, popular_lists=popular_lists, image_lists=image_lists, video_lists=video_lists, categories=categories)


def index():
    limitby=4
    #flashes just one time
    if not session.flashed:
       response.flash={'info':T("Welcome to topl1st")}
       session.flashed=True
    
    latest_lists = db(db.top_list.id > 0).select(orderby=~db.top_list.created_on,limitby=(0,limitby))
    popular_lists = db(db.top_list.id > 0).select(orderby=~db.top_list.likes,limitby=(0,limitby))
    video_lists = db((db.top_list.id > 0) & (db.top_list.category_id == 31)).select(orderby=~db.top_list.likes,limitby=(0,limitby))
    image_lists = db((db.top_list.id > 0) & (db.top_list.category_id == 30)).select(orderby=~db.top_list.likes,limitby=(0,limitby))
    recommended_lists = db((db.top_list.id > 0) & (db.top_list.is_recommended==True)).select(orderby=~db.top_list.likes,limitby=(0,limitby))
    count = db.top_list.id.count()
    categories=db().select(db.category.id,db.category.name, count, 
        left=db.top_list.on(db.category.id==db.top_list.category_id),groupby=db.category.id,orderby=~count)
    
    return dict(latest_lists=latest_lists, popular_lists=popular_lists, image_lists=image_lists, video_lists=video_lists, categories=categories,recommended_lists=recommended_lists)


def about():
    return dict()


def how_this_works():
    return dict()


def privacy():
    return dict()

    
def tos():
    return dict()


def lists():
    sorts={'recent':~db.top_list.created_on,
           'popular':~db.top_list.likes}
    try: sort=request.args[1]
    except: sort='popular'
    if sort=='recommended':
        rec=True
        orderby=sorts['popular']
    else:
        rec=False
        orderby=sorts[sort]
    try: 
        category_id=int(request.args(0))
        category=db.category(request.args(0)).name
    except:
        category_id=0
        category='All Lists'
    if rec==True:
        category='Recommended Lists'
        top_lists=db((db.top_list.id>0) & (db.top_list.is_recommended==True)).select(orderby=orderby)
    elif category_id == 0:
        top_lists=db(db.top_list.id>0).select(orderby=orderby)
    else:
        top_lists=db(db.top_list.category_id==category_id).select(orderby=orderby)
    return dict(category=category,top_lists=top_lists,sort=sort,sorts=sorts.keys())
    

def lists2():
    sorts={'recent':~db.top_list.created_on,
           'popular':~db.top_list.likes}
    items_per_page=20
    try: page=int(request.args[2])
    except: page=0
    try: sort=request.args[1]
    except: sort='popular' 
    orderby=sorts[sort]
    try: 
        category_id=int(request.args(0))
        category=db.category(request.args(0)).name
    except: 
        category_id=0
        category='All Lists'
    limitby=(items_per_page*page,(page+1)*items_per_page+1)
    if category_id == 0:
        top_lists=db(db.top_list.id>0).select(orderby=orderby,limitby=limitby)
        total=db(db.top_list.id>0).count()
    else:
        top_lists=db(db.top_list.category_id==category_id).select(orderby=orderby,limitby=limitby)
        total=db(db.top_list.category_id==category_id).count()
    return dict(category=category,top_lists=top_lists,sort=sort,sorts=sorts.keys(),page=page,items_per_page=items_per_page,total=total)


@auth.requires_login()
def list_top_lists():
    top_lists=db(db.top_list.id>0).select(orderby=db.top_list.id)
    return dict(top_lists=top_lists)


@auth.requires_login()    
def make_list():
    if (auth.user and auth.user.manager):
        form=SQLFORM(db.top_list, ignore_rw=True, \
            fields=['name','category_id','description','is_sponsored','is_recommended','is_official','is_voteable'], \
            labels = {'category_id':'Category:'})
    else:
        form=SQLFORM(db.top_list,labels = {'category_id':'Category:'})
    if form.accepts(request.vars,session):
        top_list_id=form.vars.id
        top_list=db.top_list[top_list_id] or redirect(error_page)
        #response.headers['web2py-component-command'] = \
        #'web2py_ajax_page("GET","%s","","new_top_list");web2py_ajax_page("GET","%s","","new_list_item")' \
        #% (URL(r=request,f='list',args=[top_list_id]),URL(r=request,f="new_list_item",args=[top_list_id]))
        message=T("Added new list")
        session.flash={'info':message}
        redirect(URL('top_list',args=(form.vars.id,'new')))
    elif form.errors:
        message=T("There was a problem")
        response.flash={'warn':message}
    else:
        message=T("Oops! Something went wrong")
        #response.flash=message
    return dict(form=form)
    #return dict()


@auth.requires_login()
def new_list():
    if (auth.user and auth.user.manager):
        form=SQLFORM(db.top_list, ignore_rw=True, \
            fields=['name','category_id','description','is_sponsored','is_recommended','is_official','is_voteable'], \
            labels = {'category_id':'Category:'})
    else:
        form=SQLFORM(db.top_list,labels = {'category_id':'Category:'})
    if form.accepts(request.vars,session):
        top_list_id=form.vars.id
        top_list=db.top_list[top_list_id] or redirect(error_page)
        #response.headers['web2py-component-command'] = \
        #'web2py_ajax_page("GET","%s","","new_top_list");web2py_ajax_page("GET","%s","","new_list_item")' \
        #% (URL(r=request,f='list',args=[top_list_id]),URL(r=request,f="new_list_item",args=[top_list_id]))
        message=T("Added new list")
        session.flash={'info':message}
        redirect(URL('top_list',args=(form.vars.id,'new')))
    elif form.errors:
        message=T("There was a problem")
        response.flash={'warn':message}
    else:
        message=T("Oops! Something went wrong")
        #response.flash=message
    return dict(form=form)


@auth.requires_login()
def new_list_item():
    if not request.args(0)>0:
        top_list_id=request.vars.top_list_id
    else:
        top_list_id=request.args(0)
    form=SQLFORM(db.list_item,hidden=dict(top_list_id=top_list_id))
    if len(request.vars): 
        request.vars._formkey = session['_formkey[list_item_create]']
    if form.accepts(request.vars, session, formname='list_item_create', dbio=False):
        list_item_id=db.list_item.insert(**db.list_item._filter_fields(form.vars))
        lists_id=db.lists.insert(top_list_id=top_list_id, list_item_id=list_item_id)
        response.headers['web2py-component-command'] = \
        'web2py_ajax_page("GET","%s","","top_list_items");' \
        % (URL(r=request,f="list_items",args=[top_list_id]))
        message=T("List item added")
        response.flash={'info':message}
    elif form.errors:
        message=T("There was a problem")
        response.flash={'warn':message}
    else:
        message=T("Oops! Something went wrong")
        #response.flash=message
    return dict(form=form,top_list_id=top_list_id,cknum=request.vars.CKEditorFuncNum)

	
def top_list():
	top_list_id=request.args(0)
	newrec=False
	if request.args(1)=='new':
	    newrec=True
	top_list=db.top_list(top_list_id,active=True) or redirect(error_page)
	return dict(top_list=top_list, newrec=newrec)


def list():
	top_list_id=request.args(0)
	top_list=db.top_list(top_list_id,active=True) or redirect(error_page)
	return dict(top_list=top_list)


def top_list_read():
    record = db.top_list(request.args(0)) or redirect(URL('error'))
    form=crud.read(db.top_list,record)
    return dict(form=form)


def list_items():
    top_list_id=request.args(0)
    sub = db((db.top_list.id==db.lists.top_list_id) & (db.list_item.id==db.lists.list_item_id))
    top_list_items=sub(db.lists.top_list_id==top_list_id).select()
    return dict(top_list_items=top_list_items,top_list_id=top_list_id)
    
    
def top_list_items():
    top_list_id=request.args(0)
    is_voteable=request.args(1)
    sub = db((db.top_list.id==db.lists.top_list_id) & (db.list_item.id==db.lists.list_item_id))
    orderby=db.lists.votes
    top_list_items=sub(db.lists.top_list_id==top_list_id).select(orderby=~db.lists.votes)
    return dict(top_list_items=top_list_items,top_list_id=top_list_id,is_voteable=is_voteable)
    

@auth.requires_login()
def top_list_update():
    record = db.top_list(request.args(0),active=True) or redirect(URL('error'))
    form=crud.update(db.top_list,record,next='top_list_read/[id]',
                     ondelete=lambda form: redirect(URL('top_list_select')),
                     onaccept=crud.archive)
    return dict(form=form)
    

@auth.requires_login()
def edit_list():
    record = db.top_list(request.args(0),active=True) or redirect(URL('error'))
    if (auth.user and auth.user.manager):
        form=SQLFORM(db.top_list, record=record, deletable=True, ignore_rw=True, \
            fields=['name','category_id','description','is_sponsored','is_recommended','is_official','is_voteable'], \
            labels = {'category_id':'Category:'})
    else:
        form=crud.update(db.top_list,record,next='top_list_read/[id]',
                     ondelete=lambda form: redirect(URL('top_list_select')),
                     onaccept=crud.archive)
    if form.accepts(request.vars, session):
        message=T("Updates done")
        response.flash = {'info':message}
    elif form.errors:
        message=T("The form has errors")
        response.flash = {'warn':message}
    return dict(form=form)


@auth.requires_login()
def top_list_select():
    f,v=request.args(0),request.args(1)
    try: query=f and db.top_list[f]==v or db.top_list
    except: redirect(URL('error'))
    rows=db(query)(db.top_list.active==True).select()
    return dict(rows=rows)


def top_list_search():
    form, rows=crud.search(db.top_list,query=db.top_list.active==True)
    return dict(form=form, rows=rows)


@auth.requires_login()
def list_item_create():
    form=crud.create(db.list_item,next='list_item_read/[id]')
    return dict(form=form)


def list_item_read():
    record = db.list_item(request.args(0)) or redirect(URL('error'))
    form=crud.read(db.list_item,record)
    return dict(form=form)


@auth.requires_login()
def list_item_update():
    record = db.list_item(request.args(0),active=True) or redirect(URL('error'))
    form=crud.update(db.list_item,record,next='list_item_read/[id]',
                     ondelete=lambda form: redirect(URL('list_item_select')),
                     onaccept=crud.archive)
    return dict(form=form)


@auth.requires_login()
def list_item_select():
    f,v=request.args(0),request.args(1)
    try: query=f and db.list_item[f]==v or db.list_item
    except: redirect(URL('error'))
    rows=db(query)(db.list_item.active==True).select()
    return dict(rows=rows)


def list_item_search():
    form, rows=crud.search(db.list_item,query=db.list_item.active==True)
    return dict(form=form, rows=rows)


@auth.requires_login()
def category_create():
    form=crud.create(db.category,next='category_read/[id]')
    return dict(form=form)


@auth.requires_login()
def category_read():
    record = db.category(request.args(0)) or redirect(URL('error'))
    form=crud.read(db.category,record)
    return dict(form=form)


@auth.requires_login()
def category_update():
    record = db.category(request.args(0),active=True) or redirect(URL('error'))
    form=crud.update(db.category,record,next='category_read/[id]',
                     ondelete=lambda form: redirect(URL('category_select')),
                     onaccept=crud.archive)
    return dict(form=form)


def categories():
    f,v=request.args(0),request.args(1)
    try: query=f and db.category[f]==v or db.category
    except: redirect(URL('error'))
    count = db.top_list.id.count()
    categories=db().select(db.category.id,db.category.name, count, 
        left=db.top_list.on(db.category.id==db.top_list.category_id),groupby=db.category.id,orderby=~count)
    return dict(categories=categories)


def cats():
    f,v=request.args(0),request.args(1)
    try: query=f and db.category[f]==v or db.category
    except: redirect(URL('error'))
    count = db.top_list.id.count()
    categories=db().select(db.category.id,db.category.name, count, 
        left=db.top_list.on(db.category.id==db.top_list.category_id),groupby=db.category.id,orderby=~count)
    return dict(categories=categories)


@auth.requires_login()
def category_select():
    f,v=request.args(0),request.args(1)
    try: query=f and db.category[f]==v or db.category
    except: redirect(URL('error'))
    rows=db(query)(db.category.active==True).select()
    return dict(rows=rows)


@auth.requires_login()
def category_search():
    form, rows=crud.search(db.category,query=db.category.active==True)
    return dict(form=form, rows=rows)


@auth.requires_login()
def lists_create():
    form=crud.create(db.lists,next='lists_read/[id]')
    return dict(form=form)


def lists_read():
    record = db.lists(request.args(0)) or redirect(URL('error'))
    form=crud.read(db.lists,record)
    return dict(form=form)


@auth.requires_login()
def lists_update():
    record = db.lists(request.args(0),active=True) or redirect(URL('error'))
    form=crud.update(db.lists,record,next='lists_read/[id]',
                     ondelete=lambda form: redirect(URL('lists_select')),
                     onaccept=crud.archive)
    return dict(form=form)


@auth.requires_login()
def lists_select():
    f,v=request.args(0),request.args(1)
    try: query=f and db.lists[f]==v or db.lists
    except: redirect(URL('error'))
    rows=db(query)(db.lists.active==True).select()
    return dict(rows=rows)


def lists_search():
    form, rows=crud.search(db.lists,query=db.lists.active==True)
    return dict(form=form, rows=rows)    


def ajaxlivesearch(): 
    partialResult = request.vars.values()[0] 
    array = partialResult.split() 
    query = reduce(lambda a,b:a&b, [db.top_list.name.like('%'+a+'%') for a in array])
    results = db(query).select(limitby=(0,7)) 
    j = 0 
    items = [DIV(A(result.name, 
                             _id="res%s"%j, 
                             _href="#", 
                             _onclick="copyToBox($('#res%s').html ())"%j),_id="resultLiveSearch") \
    for (j,result) in enumerate(results)] 
    return TAG[''](*items)


def search():
    keywords=[]
    try:
        qval=request.vars.q
    except:
        e_title = T("Error 400!")
        e_message = T("You need to submit your search text.")         
        http_page = pretty_exceptions(e_title,e_message)
        raise HTTP(400, http_page)
    
    if qval:
        keywords = [x for x in qval.split() if len(x)>3] 
        query1=reduce(lambda a,b:a|b,[db.top_list.description.like('%'+k+'%') for k in keywords]) 
        query2=reduce(lambda a,b:a|b,[db.top_list.name.like('%'+k+'%') for k in keywords]) 
        results = db(query1|query2).select() 
    else: 
        results = '' 
    return dict(results=results, keywords=keywords)

    # 
    # try:
    #     qvalue = request.vars.q        
    # except:
    #     e_title = T("Error 400!")
    #     e_message = T("You need to submit your search text.")         
    #     http_page = pretty_exceptions(e_title,e_message)
    #     raise HTTP(400, http_page)
    # 
    # try:
    #     page = int(request.vars.page)        
    # except:
    #     page = 1
    # 
    # 
    # #begin load all base modules
    # i2p.load_mod_common() #load common modules
    # i2p.db_definitions() #define tables
    # #end load all base modules    
    # 
    # (lists, count_lists) = get_lists_with_search(page,qvalue)       
    # xml_lists = i2p.articles.get_xml_results_from_posts(posts)
    # xml_pages = i2p.articles.pagination_last_post_search(page, count_posts, qvalue)        
    # 
    # return dict(page=page, qvalue=qvalue, lists=lists, count_lists=count_lists, \
    #             xml_lists=xml_lists, xml_pages=xml_pages)


def get_lists_with_search(self, page, textSearch):
    db = self.i2p.db
    T = self.i2p.environment.T
    request = self.i2p.environment.request  
    (limit_inf, limit_sup) = get_query_limits(page, POST_LIST_PER_PAGE)
    search_list = textSearch.split()
    clean_list = []    
    for word in search_list:
        cleanword = word.strip()
        if cleanword=="":
            continue
        cleanword = cleanword.lower()            
        if len(cleanword)<=1:
            continue     
        clean_list.append(cleanword)    
    clean_list = {}.fromkeys(clean_list).keys() # Remove duplicate
    try: clean_list.remove('') 
    except: pass #remove '' 
    clean_list = clean_list[:SEARCH_MAX_WORDS] #trunc max words to search
    query = self._get_query_publish_post() #basic query
    fulltext_field = self.i2p.config.fulltext_field
    
    #contains: Bug web2py. Need to fix this
    if request.env.web2py_runtime_gae:
        if isinstance(clean_list, list ):
            query = query & (db.posts[fulltext_field].contains(clean_list))            
    else:
        for search_word in clean_list: 
            if isinstance(search_word, (unicode, str) ):
                query = query & (db.posts[fulltext_field].contains(search_word)) 
        
    last_posts = db(query).select(db.posts.ALL, 
                                  orderby=~db.posts.published_on, 
                                  limitby=(limit_inf, limit_sup))
    last_posts_count = db(query).count()                    
    return (last_posts, last_posts_count)


@auth.requires_login()
def list_like():

    try:
        top_list_id = int(request.args[0])        
    except:     
        e_title = T("Error 400!")
        e_message = T("Problem with Top List ID.")           
        http_page = pretty_exception(e_title,e_message)
        raise HTTP(400, http_page) 

    user_id = session.auth.user.id
    list_likes = db((db.list_likes.author_id == user_id) & (db.list_likes.top_list_id == top_list_id)).select()
    if not list_likes:
        newid = db.list_likes.insert(author_id=user_id, top_list_id=top_list_id, vote=1)
        top_list = db.top_list(top_list_id)
        lcount = top_list.likes + 1
        top_list.update_record(likes=lcount)
        message = T('You have liked this list!')      
        response.flash = {'info':message}        
    else:
        message=T("You've already liked this Top List")
        response.flash = {'warn':message}

    return dict(message=message)


@auth.requires_login()
def item_vote():

    try:
        top_list_id = int(request.args[0])      
    except:     
        e_title = T("Error 400!")
        e_message = T("Problem with Top List ID.")           
        http_page = pretty_exception(e_title,e_message)
        raise HTTP(400, http_page)

    try:
        list_item_id = int(request.args[1])      
    except:     
        e_title = T("Error 400!")
        e_message = T("Problem with Top List ID.")           
        http_page = pretty_exception(e_title,e_message)
        raise HTTP(400, http_page)

    user_id = session.auth.user.id
    list_votes = db((db.list_votes.author_id == user_id) & (db.list_votes.list_item_id == list_item_id) & (db.list_votes.top_list_id == top_list_id)).select()
    if not list_votes:
        newid = db.list_votes.insert(author_id=user_id, top_list_id=top_list_id, list_item_id=list_item_id, vote=1)
        newcnt = db((db.lists.top_list_id==top_list_id) & (db.lists.list_item_id==list_item_id)).select().first()
        tempcnt = newcnt.votes + 1
        newcnt.update_record(votes=tempcnt)
        message = T('Thanks for voting!')      
        session.flash = {'info':message}        
    else:
        message=T("You've already voted for this")
        session.flash = {'warn':message}
        
    redirect(request.env.http_referer)


@auth.requires_login()
def vote():
    if request.env.request_method!='POST': raise HTTP(400)
    user_id = session.auth.user.id
    list_item_id = request.vars.item_id
    top_list_id = request.vars.list_id
    list_votes = db((db.list_votes.author_id == user_id) & (db.list_votes.list_item_id == list_item_id) &  (db.list_votes.top_list_id == top_list_id)).select()
    newcnt = db((db.lists.top_list_id==top_list_id) & (db.lists.list_item_id==list_item_id)).select().first()
    if not list_votes:
        newid = db.list_votes.insert(author_id=user_id, top_list_id=top_list_id, list_item_id=list_item_id, vote=1)
        tempcnt = newcnt.votes + 1
        newcnt.update_record(votes=tempcnt)
        message = T('Thanks for voting!')      
        response.flash = {'info':message}        
    else:
        tempcnt = newcnt.votes
        message=T("You've already voted for this")
        response.flash = {'warn':message}
    return str(tempcnt)

    #return str(voters_count(top_list_id,list_item_id))


def user():
    """
    exposes:
    http://..../[app]/default/user/login
    http://..../[app]/default/user/logout
    http://..../[app]/default/user/register
    http://..../[app]/default/user/profile
    http://..../[app]/default/user/retrieve_password
    http://..../[app]/default/user/change_password
    use @auth.requires_login()
        @auth.requires_membership('group name')
        @auth.requires_permission('read','table name',record_id)
    to decorate functions that need access control
    """
    return dict(form=auth())


def download():
    """
    allows downloading of uploaded files
    http://..../[app]/default/download/[filename]
    """
    return response.download(request,db)


def call():
    """
    exposes services. for example:
    http://..../[app]/default/call/jsonrpc
    decorate with @services.jsonrpc the functions to expose
    supports xml, json, xmlrpc, jsonrpc, amfrpc, rss, csv
    """
    session.forget()
    return service()