# -*- coding: utf-8 -*-
#
# Web2py Application Exhibition ( Version 2.0 ) 
# Copyright (c) 2010 Mulone, Pablo Martín 
# https://bitbucket.org/mulonemartin/exhibition
#
# License Code: GPL, General Public License v. 2.0
# License Content: Creative Commons Attribution 3.0 
#
# Also visit: www.web2py.com 
#             or Groups: http://groups.google.com/group/web2py 
#                http://groups.google.com/group/web2py-usuarios  
#
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>

import time
now=time.time()

#is user an admin
def is_user_an_admin():
    
    if request.env.web2py_runtime_gae:
        from google.appengine.api import users
        if users.is_current_user_admin():
            return True        
    else:
        if 'auth' in globals():
            if auth.is_logged_in():   
                is_admin = auth.has_membership(auth.id_group("Admin"))
                if is_admin:
                    return True    
    return False

#is user logged in
def is_user_logged_in():
    logged_in=False
    if 'auth' in globals():
        if auth.is_logged_in():
            logged_in=True 
    
    return logged_in