# coding: utf8
import datetime

db.define_table('category',
    Field('id','id',
          represent=lambda id:SPAN(id,' ',A('view',_href=URL('category_read',args=id)))),
    Field('name', type='string', unique=True,
          label=T('Name')),
    Field('active','boolean',default=True,
          label=T('Active'),writable=False,readable=False),
    Field('created_on','datetime',default=request.now,
          label=T('Created On'),writable=False,readable=False),
    Field('modified_on','datetime',default=request.now,
          label=T('Modified On'),writable=False,readable=False,
          update=request.now),
    Field('created_by',db.auth_user,default=auth.user_id,
          label=T('Created By'),writable=False,readable=False),
    Field('modified_by',db.auth_user,default=auth.user_id,
          label=T('Modified By'),writable=False,readable=False,
          update=auth.user_id),
    format='%(name)s',
    migrate=True)

db.define_table('category_archive',db.category,Field('current_record','reference category'))

db.define_table('top_list',
    Field('id','id',
          represent=lambda id:SPAN(id,' ',A('view',_href=URL('top_list_read',args=id)))),
    Field('name', type='string', notnull=True, unique=True,
          label=T('Name')),
    Field('views', type='integer',
          writable=False, readable=False, default=0,
          label=T('Views')),
    Field('likes', type='integer',
          writable=False, readable=False, default=0,
          label=T('Likes')),
    Field('share_count', type='integer',
          writable=False, readable=False, default=0,
          label=T('Share Count')),
    Field('comments', type='integer',
          writable=False, readable=False, default=0,
          label=T('Comments')),
    Field('category_id', type='reference category',
          label=T('Category ID')),
    Field('description', type='text',
          label=T('Description')),
    Field('is_sponsored', type='boolean', default=False,
          writable=False, readable=False,
          label=T('Is Sponsored')),
    Field('is_recommended', type='boolean', default=False,
          writable=False, readable=False,
          label=T('Is Recommended')),
    Field('is_official', type='boolean', default=False,
          writable=False, readable=False,
          label=T('Is Official')),
    Field('is_voteable', type='boolean', default=True,
          label=T('Is Voteable')),
    Field('active','boolean',default=True,
          label=T('Active'),writable=False,readable=False),
    Field('created_on','datetime',default=request.now,
          label=T('Created On'),writable=False,readable=False),
    Field('modified_on','datetime',default=request.now,
          label=T('Modified On'),writable=False,readable=False,
          update=request.now),
    Field('created_by',db.auth_user,default=auth.user_id,
          label=T('Created By'),writable=False,readable=False),
    Field('modified_by',db.auth_user,default=auth.user_id,
          label=T('Modified By'),writable=False,readable=False,
          update=auth.user_id),
    format='%(name)s',
    migrate=True)

db.define_table('top_list_archive',db.top_list,Field('current_record','reference top_list'))

db.define_table('list_item',
    Field('id','id',
          represent=lambda id:SPAN(id,' ',A('view',_href=URL('list_item_read',args=id)))),
    Field('name', type='string', notnull=True,
          label=T('Name')),
    Field('description', type='text', notnull=True,
          label=T('Description')),
    Field('active','boolean',default=True,
          label=T('Active'),writable=False,readable=False),
    Field('created_on','datetime',default=request.now,
          label=T('Created On'),writable=False,readable=False),
    Field('modified_on','datetime',default=request.now,
          label=T('Modified On'),writable=False,readable=False,
          update=request.now),
    Field('created_by',db.auth_user,default=auth.user_id,
          label=T('Created By'),writable=False,readable=False),
    Field('modified_by',db.auth_user,default=auth.user_id,
          label=T('Modified By'),writable=False,readable=False,
          update=auth.user_id),
    format='%(name)s',
    migrate=True)

db.define_table('list_item_archive',db.list_item,Field('current_record','reference list_item'))

db.define_table('lists',
    Field('id','id',
          represent=lambda id:SPAN(id,' ',A('view',_href=URL('lists_read',args=id)))),
    Field('top_list_id', type='reference top_list',
          label=T('Top List ID')),
    Field('list_item_id', type='reference list_item',
          label=T('List Item ID')),
    Field('votes', type='integer',
          writable=False, readable=False, default=0,
          label=T('Votes')),
    Field('comments', type='integer',
          writable=False, readable=False, default=0,
          label=T('Comments')),
    Field('active','boolean',default=True,
          label=T('Active'),writable=False,readable=False),
    Field('created_on','datetime',default=request.now,
          label=T('Created On'),writable=False,readable=False),
    Field('modified_on','datetime',default=request.now,
          label=T('Modified On'),writable=False,readable=False,
          update=request.now),
    Field('created_by',db.auth_user,default=auth.user_id,
          label=T('Created By'),writable=False,readable=False),
    Field('modified_by',db.auth_user,default=auth.user_id,
          label=T('Modified By'),writable=False,readable=False,
          update=auth.user_id),
    format='%(name)s',
    migrate=True)


db.define_table('lists_archive',db.lists,Field('current_record','reference lists'))


db.define_table('list_likes',                                  
    Field('id', 'id',
          represent=lambda id:SPAN(id,' ',A('view',_href=URL('list_likes_read',args=id)))),
    Field('top_list_id', 'integer',
          required=True,writable=False,readable=False,
          label=T('Top List ID')), 
    Field('author_id', 'integer',
          required=True,writable=False,readable=False,
          label=T('Author ID')),    
    Field('vote', 'integer', default=0,
          required=True,writable=False,readable=False,
          label=T('Vote')),
    format='%(name)s',                                                                                                                
    migrate=True)


db.define_table('list_votes',                                  
    Field('id', 'id',
          represent=lambda id:SPAN(id,' ',A('view',_href=URL('list_likes_read',args=id)))),
    Field('top_list_id', 'integer',
          required=True,writable=False,readable=False,
          label=T('Top List ID')),
    Field('list_item_id', 'integer',
          required=True,writable=False,readable=False,
          label=T('List Item ID')), 
    Field('author_id', 'integer',
          required=True,writable=False,readable=False,
          label=T('Author ID')),    
    Field('vote', 'integer', default=0,
          required=True,writable=False,readable=False,
          label=T('Vote')),
    format='%(name)s',                                                                                                                
    migrate=True)


db.list_likes.top_list_id.requires = IS_IN_DB(db,'top_list.id','top_list.id')
db.list_likes.author_id.requires = IS_IN_DB(db,'auth_user.id','auth_user.email')
db.list_votes.top_list_id.requires = IS_IN_DB(db,'top_list.id','top_list.id')
db.list_votes.author_id.requires = IS_IN_DB(db,'auth_user.id','auth_user.email')
db.list_votes.list_item_id.requires = IS_IN_DB(db,'list_item.id','list_item.id')
db.category.name.requires=[IS_NOT_EMPTY(),IS_NOT_IN_DB(db,'category.name')]
db.top_list.name.requires=[IS_NOT_EMPTY(),IS_NOT_IN_DB(db,'top_list.name')]
db.top_list.description.requires=[IS_NOT_EMPTY(),IS_LENGTH(minsize=8)]
db.top_list.category_id.requires=IS_IN_DB(db,'category.id','category.name')
db.list_item.name.requires=IS_NOT_EMPTY()
db.list_item.description.requires=IS_NOT_EMPTY()
db.lists.top_list_id.requires=IS_IN_DB(db,'top_list.id','top_list.name')
db.lists.list_item_id.requires=IS_IN_DB(db,'list_item.id','list_item.name')
